igeo

## Class ITensionOnCurve

- java.lang.Object
- - igeo.IDynamicsBase
  - - igeo.ITensionOnCurve

- All Implemented Interfaces:
    IDynamics, ISubobject, ITensionI

      public class ITensionOnCurve
      extends IDynamicsBase
      implements ITensionI

  Class of IDynamics to simulate tension force between two particles on curve based on distance in u parameter space.
  Author:
    Satoru Sugihara

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `boolean` | `constantTension` if constantTension is true, amount of force is always constant and it's equals to tension.
    `boolean` | `isCurveClosed`
    `double` | `maxTension`
    `IParticleOnCurveI` | `pt1`
    `IParticleOnCurveI` | `pt2`
    `double` | `tension` tension is a coefficient to convert distance of two points to amount of force.

    - ### Fields inherited from class igeo.IDynamicsBase

      `parent, targets`

    - ### Fields inherited from interface igeo.ITensionI

      `defaultTension`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ITensionOnCurve(IParticleOnCurveI p1, IParticleOnCurveI p2)`
    `ITensionOnCurve(IParticleOnCurveI p1, IParticleOnCurveI p2, double tension)`
    `ITensionOnCurve(IParticleOnCurveI p1, IParticleOnCurveI p2, double tension, IObject parent)`
    `ITensionOnCurve(IParticleOnCurveI p1, IParticleOnCurveI p2, IObject parent)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `constant()` if constantTension is true, amount of force is always constant and it's equals to tension.
    `ITensionOnCurve` | `constant(boolean cnst)` if constantTension is true, amount of force is always constant and it's equals to tension.
    `void` | `interact(java.util.ArrayList<IDynamics> dynamics)` behavior definition of interaction with other dynamic objects.
    `double` | `maxTension()` if maxTension is set to be positive number, it limits the force (distance * tension) is cut off at maxTension.
    `ITensionOnCurve` | `maxTension(double maxTension)` if maxTension is set to be positive number, it limits the force (distance * tension) is cut off at maxTension if constant is set, maxTension is ignored.
    `ITensionOnCurve` | `parent(IObject par)` setting parent object
    `IParticleI` | `particle(int i)` alias of pt(int)
    `IParticleI` | `particle1()` alias of pt1()
    `IParticleI` | `particle2()` alias of pt2()
    `IVec` | `pos(int i)` position of particle(int i)
    `IVec` | `pos1()` position of particle1
    `IVec` | `pos2()` position of particle2
    `IParticleI` | `pt(int i)` getting end point.
    `IParticleI` | `pt1()` getting end point1.
    `IParticleI` | `pt2()` getting end point2.
    `ITensionOnCurve` | `removeTarget(int i)` remove target object.
    `ITensionOnCurve` | `removeTarget(IObject obj)` remove target object.
    `ITensionOnCurve` | `target(IObject targetObj)` add terget object to be updated by this dynamic object.
    `double` | `tension()` tension is a coefficient to convert distance of two points to amount of force.
    `ITensionOnCurve` | `tension(double tension)` tension is a coefficient to convert distance of two points to amount of force.
    `void` | `update()` behavior definition of updating dynamics in each time frame

    - ### Methods inherited from class igeo.IDynamicsBase

      `initDynamicsBase, initDynamicsBase, initDynamicsBase, localDynamics, parent, postinteract, postupdate, preinteract, preupdate, target, targetNum, targets, updateTarget`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### pt1

          public IParticleOnCurveI pt1

    - #### pt2

          public IParticleOnCurveI pt2

    - #### tension

          public double tension

      tension is a coefficient to convert distance of two points to amount of force.

    - #### constantTension

          public boolean constantTension

      if constantTension is true, amount of force is always constant and it's equals to tension. Only direction of force changes. But if the distance is zero, force is also zero.

    - #### maxTension

          public double maxTension

    - #### isCurveClosed

          public boolean isCurveClosed

  - ### Constructor Detail

    - #### ITensionOnCurve

          public ITensionOnCurve(IParticleOnCurveI p1,
                         IParticleOnCurveI p2,
                         double tension,
                         IObject parent)

    - #### ITensionOnCurve

          public ITensionOnCurve(IParticleOnCurveI p1,
                         IParticleOnCurveI p2,
                         IObject parent)

    - #### ITensionOnCurve

          public ITensionOnCurve(IParticleOnCurveI p1,
                         IParticleOnCurveI p2,
                         double tension)

    - #### ITensionOnCurve

          public ITensionOnCurve(IParticleOnCurveI p1,
                         IParticleOnCurveI p2)

  - ### Method Detail

    - #### tension

          public double tension()

      Description copied from interface: `ITensionI`
      tension is a coefficient to convert distance of two points to amount of force.
      Specified by:
        `tension` in interface `ITensionI`

    - #### tension

          public ITensionOnCurve tension(double tension)

      Description copied from interface: `ITensionI`
      tension is a coefficient to convert distance of two points to amount of force.
      Specified by:
        `tension` in interface `ITensionI`

    - #### constant

          public boolean constant()

      Description copied from interface: `ITensionI`
      if constantTension is true, amount of force is always constant and it's equals to tension. Only direction of force changes. But if the distance is zero, force is also zero.
      Specified by:
        `constant` in interface `ITensionI`

    - #### constant

          public ITensionOnCurve constant(boolean cnst)

      Description copied from interface: `ITensionI`
      if constantTension is true, amount of force is always constant and it's equals to tension. Only direction of force changes. But if the distance is zero, force is also zero.
      Specified by:
        `constant` in interface `ITensionI`

    - #### maxTension

          public double maxTension()

      if maxTension is set to be positive number, it limits the force (distance * tension) is cut off at maxTension. if constant is set, maxTension is ignored.
      Specified by:
        `maxTension` in interface `ITensionI`

    - #### maxTension

          public ITensionOnCurve maxTension(double maxTension)

      if maxTension is set to be positive number, it limits the force (distance * tension) is cut off at maxTension if constant is set, maxTension is ignored.
      Specified by:
        `maxTension` in interface `ITensionI`

    - #### pt

          public IParticleI pt(int i)

      getting end point. i==0 or i==1
      Specified by:
        `pt` in interface `ITensionI`

    - #### particle

          public IParticleI particle(int i)

      alias of pt(int)
      Specified by:
        `particle` in interface `ITensionI`

    - #### pos

          public IVec pos(int i)

      position of particle(int i)
      Specified by:
        `pos` in interface `ITensionI`

    - #### pt1

          public IParticleI pt1()

      getting end point1.
      Specified by:
        `pt1` in interface `ITensionI`

    - #### particle1

          public IParticleI particle1()

      alias of pt1()
      Specified by:
        `particle1` in interface `ITensionI`

    - #### pos1

          public IVec pos1()

      position of particle1
      Specified by:
        `pos1` in interface `ITensionI`

    - #### pt2

          public IParticleI pt2()

      getting end point2.
      Specified by:
        `pt2` in interface `ITensionI`

    - #### particle2

          public IParticleI particle2()

      alias of pt2()
      Specified by:
        `particle2` in interface `ITensionI`

    - #### pos2

          public IVec pos2()

      position of particle2
      Specified by:
        `pos2` in interface `ITensionI`

    - #### parent

          public ITensionOnCurve parent(IObject par)

      Description copied from interface: `ISubobject`
      setting parent object
      Specified by:
        `parent` in interface `ISubobject`
      Overrides:
        `parent` in class `IDynamicsBase`

    - #### target

          public ITensionOnCurve target(IObject targetObj)

      Description copied from class: `IDynamicsBase`
      add terget object to be updated by this dynamic object.
      Specified by:
        `target` in interface `IDynamics`
      Overrides:
        `target` in class `IDynamicsBase`

    - #### removeTarget

          public ITensionOnCurve removeTarget(int i)

      Description copied from class: `IDynamicsBase`
      remove target object.
      Specified by:
        `removeTarget` in interface `IDynamics`
      Overrides:
        `removeTarget` in class `IDynamicsBase`

    - #### removeTarget

          public ITensionOnCurve removeTarget(IObject obj)

      Description copied from class: `IDynamicsBase`
      remove target object.
      Specified by:
        `removeTarget` in interface `IDynamics`
      Overrides:
        `removeTarget` in class `IDynamicsBase`

    - #### interact

          public void interact(java.util.ArrayList<IDynamics> dynamics)

      Description copied from class: `IDynamicsBase`
      behavior definition of interaction with other dynamic objects. The server puts all dynamic objects including itself.
      Specified by:
        `interact` in interface `IDynamics`
      Overrides:
        `interact` in class `IDynamicsBase`

    - #### update

          public void update()

      Description copied from class: `IDynamicsBase`
      behavior definition of updating dynamics in each time frame
      Specified by:
        `update` in interface `IDynamics`
      Overrides:
        `update` in class `IDynamicsBase`